<template lang="pug">

.container
  .activity__block
    app-create-link(
    :slug="createEventSlug"
    :linkText="linkText")

  app-data-grid(
    :loading="pageLoading"
    :dataArray="data.vacancies"
    :changePage="changePage"
    :columnNameWidth="dataGridLinkWidth"
    :linkName="dataGridLinkName"
    :activityView="true"
    :propDataGrid='propDataGrid'
    :deletePermission="'isFormCreator'"
    :editPermission="'isFormEditor'"
    @delete-item="deleteNewsItem"
    :paginationObj="data.pagination"
    :childComponent="'vacancies/'")

</template>

<script>
import CreateLink from '../../../components/admin/CreateLink.vue';
import DataGrid from '../../../components/admin/DataGrid.vue';

export default {
  layout: 'admin',
  name: 'AdminVacancies',
  components: {
    'app-create-link': CreateLink,
    'app-data-grid': DataGrid
  },
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/vacancies', {
      params: {
        sort: {
          id: -1
        },
        pagination: {
          perPage: 10,
          currentPage: 1
        }
      }
    });
    return { data: data };
  },
  data() {
    return {
      perPage: 10,
      page: 1,
      pageLoading: false,
      linkText: 'вакансию',
      dataGridLinkName: {
        name: 'Название вакансии',
        attrName: 'name'
      },
      propDataGrid: [
        {
          name: 'created_at',
          label: 'Дата создания',
          width: '220'
        }
      ],
      dataGridLinkWidth: '530',
      createEventSlug: '/admin/vacancies/new-vacancy',
      formLoad: true
    };
  },
  created() {
    this.$store.commit('pages', []);
    this.$store.commit('headingTitle', 'Вакансии');
    this.$store.commit('publicLink', '/about/vacancies');
    this.$store.commit('id', null);
  },
  mounted() {
    this.createDate();
    this.$nextTick(() => {
      window.addEventListener('resize', this.getWindowWidth);
    });

    this.getWindowWidth();
  },
  methods: {
    createDate() {
      if (this.data.vacancies.length) {
        this.data.vacancies.forEach(item => {
          item.created_at = `${this.$moment(item.created_at).format(
            'D.MM.YY'
          )}, в ${this.$moment(item.created_at).format('H:mm')}`;
        });
      }
    },
    deleteNewsItem(id) {
      this.pageLoading = true;
      this.$axios
        .delete(`/api/v1/vacancies/${id}`)
        .then(data => {
          this.$axios
            .get('/api/v1/vacancies', {
              params: {
                sort: {
                  id: -1
                },
                pagination: {
                  perPage: this.perPage,
                  currentPage: this.page
                }
              }
            })
            .then(data => {
              this.rewriteNewsData(data);
              this.$message.warning('Успешно удалено!');
            });
        })
        .catch(() => {
          this.pageLoading = false;
          this.$message.error('Ошибка удаления!');
        });
    },
    rewriteNewsData(data) {
      this.data = data.data;
      let pagination = data.data.pagination;
      if (
        Math.ceil(pagination.totalPageCount / pagination.perPage) <
          pagination.currentPage &&
        pagination.currentPage - 1 > 0
      ) {
        this.changePage(pagination.currentPage - 1);
      }
      this.createDate();
      this.pageLoading = false;
    },
    changePage(value) {
      this.pageLoading = true;
      this.page = value;
      this.$axios
        .get('/api/v1/vacancies', {
          params: {
            sort: {
              id: -1
            },
            pagination: {
              perPage: this.perPage,
              currentPage: value
            }
          }
        })
        .then(data => {
          this.data = data.data;
          this.createDate();
          this.pageLoading = false;
        });
    },
    getWindowWidth() {
      if (this.$parent.$currentViewport.label === 'desktop-medium') {
        this.dataGridLinkWidth = '350';
      } else if (
        this.$parent.$currentViewport.label === 'mobile' ||
        this.$parent.$currentViewport.label === 'tablet'
      ) {
        this.dataGridLinkWidth = '250';
      } else {
        this.dataGridLinkWidth = '530';
      }
    }
  }
};
</script>
